From 1f3dde12d06bb325f51ecba2bbd48b4040474136 Mon Sep 17 00:00:00 2001
From: Ingela Anderton Andin <ingela@erlang.org>
Date: Tue, 18 Jun 2019 17:37:03 +0200
Subject: [PATCH 47/73] ssl: Fix hibernation bug

---
 lib/ssl/src/tls_connection.erl   | 2 +-
 lib/ssl/test/ssl_basic_SUITE.erl | 4 +++-
 2 files changed, 4 insertions(+), 2 deletions(-)

diff --git a/lib/ssl/src/tls_connection.erl b/lib/ssl/src/tls_connection.erl
index 52e5db731a8..0129ba8ebc9 100644
--- a/lib/ssl/src/tls_connection.erl
+++ b/lib/ssl/src/tls_connection.erl
@@ -207,7 +207,7 @@ next_event(StateName, Record, State) ->
 next_event(StateName, no_record, State0, Actions) ->
     case next_record(State0) of
  	{no_record, State} ->
-            {next_state, StateName, State, Actions};
+            ssl_connection:hibernate_after(StateName, State, Actions);
  	{#ssl_tls{} = Record, State} ->
  	    {next_state, StateName, State, [{next_event, internal, {protocol_record, Record}} | Actions]};
 	#alert{} = Alert ->
diff --git a/lib/ssl/test/ssl_basic_SUITE.erl b/lib/ssl/test/ssl_basic_SUITE.erl
index 4452adaea78..b23ef74c506 100644
--- a/lib/ssl/test/ssl_basic_SUITE.erl
+++ b/lib/ssl/test/ssl_basic_SUITE.erl
@@ -3769,7 +3769,7 @@ hibernate(Config) ->
 
     ssl_test_lib:check_result(Server, ok, Client, ok),
     
-    timer:sleep(1500),
+    ct:sleep(1500),
     {current_function, {erlang, hibernate, 3}} =
 	process_info(Pid, current_function),
     
@@ -3805,6 +3805,8 @@ hibernate_right_away(Config) ->
                     [{port, Port1}, {options, [{hibernate_after, 0}|ClientOpts]}]),
 
     ssl_test_lib:check_result(Server1, ok, Client1, ok),
+    
+    ct:sleep(1000), %% Schedule out
   
      {current_function, {erlang, hibernate, 3}} =
 	process_info(Pid1, current_function),

